var inputField;
var nLetters = 0;
var maxInput = 0;

var hasTonos, hasDiaerasis, hasTD;
var cursorPos = 0;
var cursorState = false;
var blinkTimer = null;
var input_start = 0;

var greekAlpha=
    "αβψδεφγηιξκλμνοπρστθωςχυζ\u0384\u00a8 ";
var englishAlpha=
    "abcdefghijklmnoprstuvwxyz'\" ";

var TONOS = '\u0384';
var tonosValid="aehioyv\"";
var tonosOutput="άέήίόύώ\u0385";

var DIARESIS = '\u00a8';
var diaresisValid = "iy'";
var diaresisOutput = "ϊϋ\u0385";

var TONOS_DIARESIS = '\u0385';
var tonosDiaresisValid = "iy";
var tonosDiaresisOutput = "ΐΰ";

function refocus()
{
    inputField.focus();
	// do nothing for now
}

function clearInput()
{
    inputField.value = "";
}

function setInput(inputId)
{
    inputField = el(inputId);
    clearInput();
    inputField.addEventListener("keydown", kpress, true);
}

function kclick(event)
{
  var n = event.target.getAttribute("id").substring(1);
  if (n == 'Enter') {
    entered();
  }
  else if (n == 'Backspace') {
    if (inputField.selectionStart > 0) {
      if (inputField.selectionStart == inputField.selectionEnd) {
        inputField.selectionStart--;
      }
      updateField('');
      inputField.selectionStart--;
      inputField.selectionEnd--;
    }
    inputField.focus();
  }
  else {
    n = parseInt(n);
    if (n < 0) {
      insertChar(String.fromCharCode(-n));
    }
    else {
      insertChar(englishKeys[n - 1]);
    }
    inputField.focus();
  }
  return false;
}

function insertChar(char) {
  var cursorPos = inputField.selectionStart;
  var value = inputField.value;
  value = value.substring(0, inputField.selectionStart) + char +
      value.substring(inputField.selectionEnd);
  inputField.value = value;
  inputField.selectionStart = cursorPos + 1;
  inputField.selectionEnd = cursorPos + 1;
}

function replaceChar(char) {
  var cursorPos = inputField.selectionStart;
  var value = inputField.value;
  value = value.substring(0, inputField.selectionStart - 1) + char +
      value.substring(inputField.selectionEnd);
  inputField.value = value;
  inputField.selectionStart = cursorPos;
  inputField.selectionEnd = cursorPos;
}

function processChar(charCode) {
    var greekChar = '\u0000';
    if (charCode.length == 1) {
        charCode = charCode.toLowerCase();
    }
    var pos = validMap.indexOf(charCode);
    if (pos >= 0) {
        pos = englishAlpha.indexOf(charCode);
        if (inputField.selectionStart == inputField.selectionEnd && inputField.selectionStart != 0) {
            var prevChar = inputField.value[inputField.selectionStart - 1];
            var accentedPos;
            var diaresis_pos = diaresisValid.indexOf(charCode);
            var tonos_diaresis_pos = tonosDiaresisValid.indexOf(charCode);
            if (prevChar == TONOS) {
                accentedPos = tonosValid.indexOf(charCode);
                if (accentedPos >= 0) {
                    replaceChar(tonosOutput[accentedPos]);
                } 
            } else if (prevChar == DIARESIS && diaresis_pos >= 0) {
                accentedPos = diaresisValid.indexOf(charCode);
                if (accentedPos >= 0) {
                    replaceChar(diaresisOutput[accentedPos]);
                } 
            } else if (prevChar == TONOS_DIARESIS) {
                accentedPos = tonosDiaresisValid.indexOf(charCode);
                if (accentedPos >= 0) {
                    replaceChar(tonosDiaresisOutput[accentedPos]);
                } 
            } else {
                greekChar = greekAlpha[pos];
            }
        } else {
            greekChar = greekAlpha[pos];
        }

        if (greekChar != '\u0000' &&
            inputField.value.length - (inputField.selectionEnd - inputField.selectionStart) < inputField.maxLength) {
            insertChar(greekChar);
        }
    }
}

/*
 * Filter out alpha keys to the valid set
 */
function kpress( theEvent )
{
  var charCode = theEvent.key;
  
  if (theEvent.defaultPrevented) {
    return; // Do nothing if the event was already processed
  }

  if (charCode.length == 1) {
      charCode = charCode.toLowerCase();
      /* check that there's no CTRL or ALT in play */
      if (! (theEvent.ctrlKey || theEvent.metaKey)) {
        processChar(charCode);
        theEvent.preventDefault();
     }
  }
  else if (charCode == 'Enter') {
      entered();
      theEvent.preventDefault();
  }
}
